﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Resources;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new MainVM();
        }
    }
    public class IdToStringConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                if (value.GetType() == typeof(DaysOfTheWeek))
                {
                    if ((DaysOfTheWeek)value == DaysOfTheWeek.Friday)
                    {
                        return DaysOfTheWeek.Friday;
                    }

                    if ((DaysOfTheWeek)value == DaysOfTheWeek.Monday)
                    {
                        return DaysOfTheWeek.Friday;
                    }
                }
                
            }

            return value;
           
                
        }


        // No need to implement converting back on a one-way binding 
        public object ConvertBack(object value, Type targetType,
          object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
    public class MainVM
    {

        public MainVM()
        {
            Data = new List<Data>
            {
                new Data { ID = 1, Day = DaysOfTheWeek.Friday, Name = "item 1" },
                new Data { ID = 2, Day = DaysOfTheWeek.Wednesday, Name = "item 2" },
                new Data { ID = 3, Day = DaysOfTheWeek.Monday, Name = "item 3" },
            };
        }

        public List<Data> Data { get; set; }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public DaysOfTheWeek Day { get; set; }
    }

    public class DaysOfTheWeekCollection : EnumDescrioptionWrapperCollection<DaysOfTheWeek> { };

    public class EnumDescrioptionWrapperCollection<T> : List<EnumDescriptionkWrapper<T>> where T : struct, IConvertible
    {
        public EnumDescrioptionWrapperCollection()
        {

            foreach (var dow in Enum.GetValues(typeof(T)))
            {
                EnumDescriptionkWrapper<T> t = new EnumDescriptionkWrapper<T>((T)dow);
                Add(t);
            }
        }
    }

    public class EnumDescriptionkWrapper<T> where T : struct, IConvertible
    {
        T _enumVal;
        public EnumDescriptionkWrapper(T enumVal)
        {
            if (!typeof(T).IsEnum)
            {
                throw new ArgumentException("T must be an enumerated type");
            }

            _enumVal = enumVal;
        }

        public T Value
        {
            get { return _enumVal; }
        }

        public string Description
        {
            get
            {
                DescriptionAttribute description = _enumVal.GetType().GetMember(_enumVal.ToString())[0].GetCustomAttributes(false).FirstOrDefault() as DescriptionAttribute;
                if (description != null)
                {
                    return description.Description;
                }

                return "";
            }
        }
    }

    public enum DaysOfTheWeek
    {
        
        Monday = 1,
       
        Tuesday = 2,
       
        Wednesday = 3,
        
        Friday = 4,
        [Description("Day 5")]
        Sunday = 5

    }

}
